'###_CREDITS_###################################################################
'screen_init 1.1
'2008-2011 by N3trunn3r
'n3trunn3r@catbone.freebasic.net
'http://catbone.freebasic.net/
'written for FreeBASIC version 0.21.1

'###_LIBRARIES_#################################################################
#include once "fbgfx.bi"

'###_SHARED_VALUES_#############################################################
dim shared  as byte     file_config:file_config=freefile
dim shared  as string   file_config_path:file_config_path="config.ini"
dim shared  as short    sc_x,sc_y,sc_col,sc_full
const       as short    sc_x_def=640
const       as short    sc_y_def=480
const       as ubyte    sc_col_def=32
const       as byte     sc_full_def=0

'###_FUNCTIONES_################################################################
'-------------------------------------------------------------------------------
declare sub config_read()
sub         config_read()
    
    open file_config_path for input as #file_config
    input #file_config,sc_x
    input #file_config,sc_y
    input #file_config,sc_col
    input #file_config,sc_full
    close
    
end sub

'-------------------------------------------------------------------------------
declare sub config_write()
sub         config_write()
    
    kill file_config_path
    
    open file_config_path for output as #file_config
    print #file_config,sc_x
    print #file_config,sc_y
    print #file_config,sc_col
    print #file_config,sc_full
    close
    
end sub

'-------------------------------------------------------------------------------
declare sub config_write_def()
sub         config_write_def()
    
    kill file_config_path
    
    open file_config_path for output as #file_config
    print #file_config,sc_x_def
    print #file_config,sc_y_def
    print #file_config,sc_col_def
    print #file_config,sc_full_def
    close
    
end sub

'-------------------------------------------------------------------------------
declare function    config_read_error() as integer
function            config_read_error() as integer
    
    dim open_error as integer
    open_error = open(file_config_path for input as #file_config)
    return open_error
    
end function

'-------------------------------------------------------------------------------
declare sub screen_init(resc_full as byte=0)
sub         screen_init(resc_full as byte=0)
    
    if resc_full = 0 then
        
        if config_read_error() > 0 then
            config_write_def()
        endif
        
        config_read()
        
        if sc_x=0 or sc_y=0 or sc_col=0 then
            config_write_def()
            config_read()
        endif
        
    endif
    
    dim as integer fullscreen
    if sc_full=1 then
        fullscreen=&h01
    else
        fullscreen=&h00
    endif
    
    screenres sc_x,sc_y,sc_col,1,fullscreen
    
end sub
