'###_CREDITS_###################################################################
'mouse 1.0
'2011 by N3trunn3r
'n3trunn3r@catbone.freebasic.net
'http://catbone.freebasic.net/
'written for FreeBASIC version 0.21.1

'###_LIBRARIES_#################################################################
#include once "fbgfx.bi"

'###_SHARED_VALUES_#############################################################
dim shared as integer   mouse_x, mouse_y
dim shared as integer   mouse_active, mouse_hit, mouse_down
dim shared as ubyte     mouse_down_speed, mouse_down_speed_timer

'###_FUNCTIONES_################################################################
declare sub mouse()
declare sub mouse_speedup()
    
'-------------------------------------------------------------------------------
sub mouse()
    
    dim as integer mouse_button
    
    getmouse mouse_x,mouse_y,,mouse_button
    
    mouse_hit = 0
    
    if mouse_button = 0 then
        mouse_active = 1
        mouse_down = 0
    elseif mouse_button = 1 then
        if mouse_active = 1 then
            mouse_active = 0
            mouse_hit = 1
        endif
        mouse_down = 1
    endif
    
    'mouse_speedup reset timer
    if mouse_down = 0 then
        mouse_down_speed_timer = 0
    endif
    
end sub

'-------------------------------------------------------------------------------
sub mouse_speedup()
    
    if mouse_down = 1 then'mouse down timer
        select case as const mouse_down_speed_timer'acceleration speeds up if mouse down
        case 0 to 9:mouse_down_speed = 170
        case 10:mouse_down_speed = 50
        case 50:mouse_down_speed = 0
        end select
        mouse_down_speed_timer = mouse_down_speed_timer + 1
        if mouse_down_speed_timer > 50 then mouse_down_speed_timer = 50
        if mouse_down_speed > 0 then
            sleep mouse_down_speed,1
        endif
    endif
    
end sub
