'###_CREDITS_###################################################################
'scale 1.0
'2010-2011 by N3trunn3r
'n3trunn3r@catbone.freebasic.net
'http://catbone.freebasic.net/
'written for FreeBASIC version 0.21.1

'###_LIBRARIES_#################################################################
#include once "3th/scale2x.bas"
#include once "3th/imagescale.bas"
#include once "3th/image_scaler.bas"

'###_SHARED_VALUES_#############################################################

'###_FUNCTIONES_################################################################
'-------------------------------------------------------------------------------
declare sub scale(image_name_source() as any ptr, image_name() as any ptr, size_x as integer, size_y as integer, filter as ubyte=0, scale_x as ushort=2, scale_y as ushort=2, max_frames as ushort=1)
sub         scale(image_name_source() as any ptr, image_name() as any ptr, size_x as integer, size_y as integer, filter as ubyte=0, scale_x as ushort=2, scale_y as ushort=2, max_frames as ushort=1)
    
    dim as ushort for_next
    dim as any ptr image_buffer(max_frames), image_buffer_b(max_frames), image_buffer_c(max_frames)
    
    for for_next = 1 to max_frames
        select case as const filter
        case 0'imagescale - enlarge
            image_name(for_next)=imagecreate(size_x * scale_x, size_y * scale_y)
            image_name(for_next)=ImageScale(image_name_source(for_next),size_x * scale_x, size_y * scale_y)
        case 1'imagescale - shrink
            image_name(for_next)=imagecreate(size_x / scale_x, size_y / scale_y)
            image_name(for_next)=ImageScale(image_name_source(for_next),size_x / scale_x, size_y / scale_y)
        case 2'ImageScale2X_1000101
            image_name(for_next)=imagecreate(size_x * 2, size_y * 2)
            ImageScale2X_1000101(image_name(for_next),image_name_source(for_next))
        case 3'ImageEagle
            image_name(for_next)=imagecreate(size_x * 2, size_y * 2)
            ImageEagle(image_name(for_next),image_name_source(for_next))
        case 4'4x scaling
            image_buffer(for_next)=imagecreate(size_x * 2, size_y * 2)
            ImageScale2X_1000101(image_buffer(for_next),image_name_source(for_next))
            image_name(for_next)=imagecreate(size_x * 4, size_y * 4)
            ImageScale2X_1000101(image_name(for_next),image_buffer(for_next))
            imagedestroy image_buffer(for_next)
        case 5'5x scaling
            image_buffer(for_next)=imagecreate(size_x * 2, size_y * 2)
            ImageScale2X_1000101(image_buffer(for_next),image_name_source(for_next))
            image_buffer_b(for_next)=imagecreate(size_x * 4, size_y * 4)
            ImageScale2X_1000101(image_buffer_b(for_next),image_buffer(for_next))
            image_buffer_c(for_next)=imagecreate(size_x * 8, size_y * 8)
            ImageScale2X_1000101(image_buffer_c(for_next),image_buffer_b(for_next))
            image_name(for_next)=imagecreate(size_x * 5, size_y * 5)
            image_name(for_next)=ImageScale(image_buffer_c(for_next),size_x * 5, size_y * 5)
            imagedestroy image_buffer(for_next)
            imagedestroy image_buffer_b(for_next)
            imagedestroy image_buffer_c(for_next)
        case 6'6x scaling
            image_buffer(for_next)=imagecreate(size_x * 2, size_y * 2)
            ImageScale2X_1000101(image_buffer(for_next),image_name_source(for_next))
            image_buffer_b(for_next)=imagecreate(size_x * 4, size_y * 4)
            ImageScale2X_1000101(image_buffer_b(for_next),image_buffer(for_next))
            image_buffer_c(for_next)=imagecreate(size_x * 8, size_y * 8)
            ImageScale2X_1000101(image_buffer_c(for_next),image_buffer_b(for_next))
            image_name(for_next)=imagecreate(size_x * 6, size_y * 6)
            image_name(for_next)=ImageScale(image_buffer_c(for_next),size_x * 6, size_y * 6)
            imagedestroy image_buffer(for_next)
            imagedestroy image_buffer_b(for_next)
            imagedestroy image_buffer_c(for_next)
        case 8'8x scaling
            image_buffer(for_next)=imagecreate(size_x * 2, size_y * 2)
            ImageScale2X_1000101(image_buffer(for_next),image_name_source(for_next))
            image_buffer_b(for_next)=imagecreate(size_x * 4, size_y * 4)
            ImageScale2X_1000101(image_buffer_b(for_next),image_buffer(for_next))
            image_name(for_next)=imagecreate(size_x * 8, size_y * 8)
            ImageScale2X_1000101(image_name(for_next),image_buffer_b(for_next))
            imagedestroy image_buffer(for_next)
            imagedestroy image_buffer_b(for_next)
        end select
    next
    
end sub
